using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace Controls
{
    [ToolboxData("<{0}:EnumDropDown runat=server></{0}:EnumDropDown>")]
    public class EnumDropDown : DropDownList
    {
        private Type m_enumType;

        public new Type DataSource
        {
            get
            {
                return m_enumType;
            }
            set
            {
                m_enumType = value;
            }
        }

        public override void DataBind()
        {
            base.DataSource = GetDataSource();
            DataValueField = "Value";
            DataTextField = "Key";
            base.DataBind();
        }

        private Dictionary<string, int> GetDataSource()
        {
            Dictionary<string, int> retval = new Dictionary<string, int>();
            string[] enumNames = Enum.GetNames(m_enumType);
            for (int i = 0; i < enumNames.Length; i++)
            {
                retval.Add(enumNames[i], (int)Enum.Parse(m_enumType, enumNames[i]));
            }
            return retval;
        }
    }
}
